unit Bilbo; // contextfreie Grammatik

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ComCtrls, ExtCtrls, ImgList;

type
  TBilbosStory = class(TForm)
    LabelStory: TLabel;
    Ausgabe: TMemo;
    BildListe: TImageList;
    Bild: TPaintBox;
    Uhr: TTimer;
    RingLinks: TImage;
    RingRechts: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Erzeuge(var Satz:String);
    procedure LabelStoryClick(Sender: TObject);
    procedure UhrTimer(Sender: TObject);
    procedure BildMouseDown(Sender: TObject; Button: TMouseButton;
                            Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
    Regel:TStrings;
    Maxregel:Integer;
    Nr:Integer;
  public
    { Public-Deklarationen }
  end;

var BilbosStory: TBilbosStory;

implementation

{$R *.DFM}
{$R HerrderRinge.res}
{$R+,Q+}

 Const crRing=1;crHand=2;crFreiHand=3;

 procedure TBilbosStory.Erzeuge(Var Satz:String);
  var VariableVorhanden:Boolean;
      Zeile,Links,Rechts,Neu:String;
      Liste:Array of String;
      I,WO,K,X:Integer;
  Begin
   Repeat
    VariableVorhanden:=False;
    For I:=0 To Maxregel Do
     Begin
      Zeile:=Regel[I];
      While Pos(' ',Zeile)>0 Do Delete(Zeile,Pos(' ',Zeile),1);
      X:=Pos('->',Zeile);
      If X>0 Then
       Begin
        Links:=Copy(Zeile,1,X-1);Rechts:=Copy(Zeile,X+2,Length(Zeile));
        X:=Pos(Links,Satz);
        If X>0 Then
         Begin
          VariableVorhanden:=True;
          WO:=Pos(',',Rechts);K:=0;SetLength(Liste,K+1);
          While WO>0 do                               
           Begin
            Liste[K]:=Copy(Rechts,1,WO-1);
            Delete(Rechts,1,WO);
            WO:=Pos(',',Rechts);
            Inc(K);SetLength(Liste,K+1);
           End;
          Liste[K]:=Rechts;
          Neu:=Liste[Random(K)];
          Delete(Satz,X,Length(Links));Insert(Neu,Satz,X)
         End;
       End;
     End;
   Until not VariableVorhanden;
   While Pos('+',Satz)>0 Do
    Begin X:=Pos('+',Satz);Delete(Satz,X,1);Insert(' ',Satz,X) End;
   While Pos('_',Satz)>0 Do Delete(Satz,Pos('_',Satz),1);
   While Pos('&',Satz)>0 Do Satz[Pos('&',Satz)]:=',';
   If Satz[1]<>'"' Then X:=1 Else X:=2;
   Satz[X]:=AnsiUppercase(Satz[X])[1]
  End;

 procedure TBilbosStory.FormCreate(Sender: TObject);
  begin
   Randomize;Nr:=0;
   Screen.Cursors[crRing]:=LoadCursor(HInstance,MakeIntResource(1));
   Screen.Cursors[crHand]:=LoadCursor(HInstance,MakeIntResource(2));
   Screen.Cursors[crFreiHand]:=LoadCursor(HInstance,MakeIntResource(3));
   Ausgabe.Cursor:=crRing;Bild.Cursor:=crHand;LabelStory.Cursor:=crFreiHand;
   RingLinks.Cursor:=crRing;RingRechts.Cursor:=crRing;
   Regel:=TStringList.Create;
   Regel.LoadFromFile('Regeln.txt');
   Maxregel:=Regel.Count-1;
  end;

 procedure TBilbosStory.LabelStoryClick(Sender: TObject);
  var I,N:Integer;
      Satz:String;
  begin
   Ausgabe.Clear;
   N:=Random(80)+20;
   For I:=1 To N Do
    Begin Satz:='START';Erzeuge(Satz);Ausgabe.Lines.Add(Satz+'.') End;
  end;

 procedure TBilbosStory.UhrTimer(Sender: TObject);
  begin
   BildListe.Draw(Bild.Canvas,0,0,Nr);
   inc(Nr);
   if Nr=14 then Nr:=0;
  end;

 procedure TBilbosStory.BildMouseDown(Sender: TObject; Button: TMouseButton;
                                      Shift: TShiftState; X, Y: Integer);
  begin
   if Button=mbLeft then
    begin
     if Uhr.Interval>100 then Uhr.Interval:=Uhr.Interval-50;
    end;
   if Button=mbRight then
    begin
     if Uhr.Interval<1000 then Uhr.Interval:=Uhr.Interval+50;
    end;
  end;

end.

